use strict;
#use warnings;
#use List::MoreUtils qw(uniq);


#### submaf : cutoff length and identity ####
#### Example: perl maff_parse.pl Chr1.submaf 20 100 > Chr1.20.100.submaf ####

my ($maf,$len,$iden)=@ARGV;


open IN, $maf;
my @tmp=<IN>;
close IN;
my $t=join "",@tmp;
my @all=split "\n\n", $t;

foreach my $i(@all){
my ($ref_len, $identy)=&line2state($i);
if ($ref_len >= $len && $identy >= $iden){
print "$i\n\n";
}
}


sub line2state{
(my $i)=@_;
my ($score, $a, $b, $c,$d,$e,$f,$g)=(split "\n",$i);
my @a=split /\s+/, $a;
my @b=split /\s+/, $b;
my @c=split /\s+/, $c;
my @d=split /\s+/, $d;
my @e=split /\s+/, $e;
my @f=split /\s+/, $f;
my @g=split /\s+/, $g;
my ($aligned_len,$iden)=&seq2iden($a[6],$b[6],$c[6],$d[6],$e[6],$f[6],$g[6]);
return ($aligned_len,$iden);
}


sub seq2iden{
my ($a, $b, $c,$d,$e,$f,$g)=@_;
my $len=length($a);
my $total=$len;
my $i_sum=0;
for (my $i=0; $i<$total; $i++){
my $a_i=substr($a,$i,1);
my $b_i=substr($b,$i,1);
my $c_i=substr($c,$i,1);
my $d_i=substr($d,$i,1);
my $e_i=substr($e,$i,1);
my $f_i=substr($f,$i,1);
my $g_i=substr($g,$i,1);
my $tmp=$a_i.$b_i.$c_i.$d_i.$e_i.$f_i.$g_i;
my @uniq = do { my %seen; grep { !$seen{$_}++ } (split "",$tmp) };
if ($tmp=~/[\-|N]/){
   $len=$len-1;
   }else{
   if (@uniq == 1){
      $i_sum++;
      }
   }
}
my $iden=0;
if ($len>0){
$iden=$i_sum/$len;
}
return ($len,$iden);
}




