##Edited by songht@20201222  cmb@bnu Email: songhongtao@bnu.edu.cn##
#####depandency tools#####
# PHAST v1.4 #
# bedtools v2.25.0 #

export wkdir="/User/wkdir"
export maf="/User/wkdir/12way.maf"
export scripts="/User/scripts" 
export coll_segment="/User/wkdir/12way_coll.bed"  # 12way collinear segments with bed file
export CDS="/User/wkdir/CDS_bed/"  #coding sequence bed file in cucumber genome
export mostCons="/User/wkdir/phast/mostCons.bed" 
export len_cut=20 #set the minimal length of elements with base pair as unit #
export iden_cut=0.8 #set the minimal alignment identitiy cutoff for screening elements #


## Step1 Retain the noncoding elements from mostCons elements ##
bedtools intersect -a $mostCons -b $CDS -v > $wkdir/mostCons_nocoding.bed 

## Step2 Retain the cis-regulatory elements that located in collinear segments ##
bedtools intersect -a $wkdir/mostCons_nocoding.bed -b $coll_segment -v > $wkdir/mostCons_nocoding_inColl.bed 

## Step3 Retain >= minimal length elements from mostCons_nocoding_inColl elements ##
awk -v len_cut=$len_cut '{if (($3-$2+1)>= len_cut){print $_}}' $wkdir/mostCons_nocoding.bed > $wkdir/mostCons_nocoding_${len_cut}.bed

## Step4 Using maf_parse to extract elements alignments based on 7way alignments ##
maf_parse  -f $wkdir/mostCons_nocoding_{$len_cut}.bed $maf  > $wkdir/elements.submaf

## Step5 Using maf_parse to extract elements alignments based on 7way alignments ##
perl $scripts/maf_parse.pl  $wkdir/elements.submaf $len_cut $iden_cut  > $wkdir/cisRCNEs.txt

## Step6 Retain elements with minimal alignment identity from elements ##
maf_parse  -f $wkdir/mostCons_nocoding_{$len_cut}.bed $maf  > $wkdir/elements.submaf
